package xyz.lychee.lagfixer.libs.adventure.text.minimessage.internal.parser.node;

import xyz.lychee.lagfixer.libs.adventure.text.minimessage.internal.parser.Token;
import xyz.lychee.lagfixer.libs.adventure.text.minimessage.internal.parser.TokenParser;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;

public final class TextNode extends ValueNode {
   private static boolean isEscape(final int escape) {
      return escape == 60 || escape == 92;
   }

   public TextNode(final @Nullable ElementNode parent, final @NotNull Token token, final @NotNull String sourceMessage) {
      super(parent, token, sourceMessage, TokenParser.unescape(sourceMessage, token.startIndex(), token.endIndex(), TextNode::isEscape));
   }

   String valueName() {
      return "TextNode";
   }
}
